#!/bin/bash

directory=$(dirname $0)
rand=$RANDOM
solutionfile="/tmp/sol0$rand.sol"
prepfile="/tmp/preprocessed$rand.wcnf"
output=$(eval $directory/maxpre2/maxpre $1 solve -solver=$directory/EvalMaxSAT.sh -solfile="$solutionfile" -prepfile="$prepfile" -verb=0 2>/dev/null)
ret=$?
#echo "ret: $ret"
echo "$output" | grep -v '^v '
values=$(echo "$output" | grep '^v ')
echo "c $values"
values=($values)
count=0

for value in "${values[@]}"
do
  if [ "$value" == "v" ]; then
    echo -n "v "
    continue
  fi
  ((count++))
  if [[ $value =~ -[0-9]+ ]]; then
    if [ "$value" != "-$count" ]; then
      echo "error in outputting result $count $value"
      exit 1
    fi
    echo -n "0"
  else
    if [ "$value" != "$count" ]; then
      echo "error in outputting result $count $value"
      exit 1
    fi

    echo -n "1"
  fi
done
echo ""
rm -f "$solutionfile"
rm -f "$prepfile"
exit "$ret"
