#!/usr/bin/env python3

import argparse
import numpy as np
import fileinput

# parser = argparse.ArgumentParser(
#     description='This is a awesome Z3 Output Converter!!')
# parser.add_argument("--Z3Output", default="", required=False,
#                     help="Z3Output")
#
# args = parser.parse_args()

model = np.array([])
var = 0
maxVar = 0

# if args.Z3Output is not None:
#     fileContent = sys.stdin.read()
#     args.Z3Output = fileContent

# with open(args.Z3Output, 'r') as file:
resultGiven=False
satisfiable=-1
for line in fileinput.input():
    # print(line)
    if var != 0:
        if line.startswith('  false'):
            model[var] = False
            # print(" 0")
        elif line.startswith('  true'):
            model[var] = True
            # print(" 1")
        else:
            print("ERROR: no boolean value found for variable " + str(var))

    var = 0
    if line.startswith('sat'):
        print("s OPTIMUM FOUND")
        satisfiable=1
    if line.startswith('unsat'):
        print("s UNSATISFIABLE")
        satisfiable=0
        exit()
    if line.startswith('unknown'):
        satisfiable=2
        print("s UNKNOWN")
        exit()
    if line.startswith('(define-fun k!'):
        var = int(line[14:].split(' ')[0])
        # print(var, end='')
        if maxVar < var:
            maxVar = var
            model.resize(maxVar+1)
    if line[3:].split('\n')[0].isnumeric():
        print("o " + str(line[3:]), end='')
        resultGiven=True


if satisfiable==-1:
    print("c ERROR: No information if satisfiable!!!")

if resultGiven==False and satisfiable==True:
    print("c No result given --> assume result to be 0!!!")
    print("o 0")
# print(model)

print("v ", end='')
for i in range(1, maxVar+1):
    if model[i] == 0:
        print("0", end='')
    else:
        print("1", end='')
print("")
