## General
This is a first version of a fuzzer release. We hope that we can soon publish it in github with some additional features and a container!

## How to install
Install with the install.sh script in the main directory
   1. builds fuzzer delta debugger from Tobias Paxian and wcnfverifier for the compare script (needs gcc) -- you can execute them from TobiasPaxian/runfuzz
   2. wgets all MaxSAT solver (wget necessary)
   3. unzips the solver (unzip necessary)
   4. clones kissat sat solver and builds it
   5. copies all scripts to TobiasPaxian/runfuzz to be able to run the wcnf fuzzer from there with TobiasPaxian/runfuzz/run.sh
          ./run.sh calls the wcnfuzz and within the deltadebugger with the compare.sh script from the directory MaxSATSolver
          solver with v at the end have a verified result
          solver with ! at the end have a unverified result
   
This is a first shot - further information will be added. Please report any issues with it!

## All files explained in short
In the following a short explanation to each file is added.

### MaxSATFuzzer/install.sh
- calls MaxSATFuzzer/MaxSATSolver/install.sh
- calls MaxSATFuzzer/TobiasPaxian/install.sh

### MaxSATFuzzer/MaxSATSolver/install.sh
- calls getSolver.sh
- builds the wcnfverifier

### MaxSATFuzzer/MaxSATSolver/getSolver.sh
- wgets all weighted MaxSAT solver from the MaxSAT evaluation 2022 and unzips them in the MaxSATSolver directory
- gets Z3 solver from github
- gets Pacose solver from MSE 21'
- gets maxpre 2.0 from github
- git clones Armin Bieres kissat SAT solver into MaxSATSolver/wcnfverifier/kissat and builds the solver

### MaxSATFuzzer/MaxSATSolver/compare.py
- IS THE WCNFcompare script, in the first lines you can deactivate some solver or add other binaries.
- calls all MaxSAT solver from the competition 2022
- tries to verify the results
- if the results differ from each other or if there is a verified wrong result exit with a code different than 0

### MaxSATFuzzer/MaxSATSolver/wcnfverifier/wcnfverifier
- for satisfiable benchmarks with given optimal solution and a model the wcnfverifier checks if the model corresponds to the optimal value
- for unsatisfiable bencharks the wcnfverifier calls the kissat sat solver and checks if the hard clauses are unsatisfiable

### MaxSATFuzzer/MaxSATSolver/wcnfverifier/kissat/build/kissat
- SAT solver from Armin Biere. Can be tested with "make test" or ./kissat ../test/cnf/<cnf-benchmark>.cnf

### MaxSATFuzzer/MaxSATSolver/#solver#.sh
- These scripts should call the MaxSATSolver with the parameters used in the MaxSAT Evaluation 22
  
### MaxSATFuzzer/TobiasPaxian/install.sh
- builds wcnfddmin
- builds wcnfuzz
- copies wcnfddmin, wcnfuzz, runwcnfuzz.sh to TobiasPaxian/runfuzz/

### MaxSATFuzzer/TobiasPaxian/runfuzz/wcnfddmin
- ./wcnfddmin -h gives you all you need
- EXAMPLE: delta debugger for wcnf files. Should work with "./wcnfddmin -C -L -e 0 -r $reducedFileName $compare.sh $buggyWcnfFile -- other options will be released soon (hopefully)

### MaxSATFuzzer/TobiasPaxian/runfuzz/wcnfuzz
- Creates one MaxSAT instance at a time "./wcnfuzz --wcnf"

### MaxSATFuzzer/TobiasPaxian/runfuzz/runwcnfuzz.sh
- Loops the fuzzer to generate maxsat instances and if a faulty file is generated call the delta debugger to shrink it
  
### MaxSATFuzzer/TobiasPaxian/runfuzz/run.sh
- calls the fuzzer in parallel

### MaxSATFuzzer/TobiasPaxian/runfuzz/run.sh
- contains some additional helpful scripts!! To generate an fault overview csv script or combines all the log files. Please only call them if you can read the code and understand it.
