#!/bin/bash

folder=$1

declare -A counts
declare -A failures

for FILENAME in "$folder"/*; do
  solver=$(basename $FILENAME | cut -d'_' -f1)
  error=$(basename $FILENAME | cut -d'_' -f2)
  #error="${error::-4}"

  key="$solver-$error"
  #echo $(basename $FILENAME)
  #echo "$FILENAME; ../../MaxSATSolver/compare.py $solver , $error, $key"
  (( counts[$key]++ ))

  output=$(../../MaxSATSolver/compare.py "$FILENAME" | grep "$solver" | grep "\!$error")
  if [ -z "$output" ]; then
    echo "$FILENAME"
    (( failures[$key]++ ))
  fi
  
done

echo ""
# Print the counts for each combination
for key in "${!counts[@]}"; do
    if [ -z "${failures[$key]}" ]; then
      echo "$key: ${failures[$key]} / ${counts[$key]}"
    fi
done

echo ""
for key in "${!counts[@]}"; do
  if [ -n "${failures[$key]}" ]; then
    echo "ERROR:  $key: ${failures[$key]} / ${counts[$key]}  failed."
  fi
done
