#!/bin/bash

folder=FaultOverview
logfile=FaultList
logfile="$(date -I)_$logfile"
logErrors=$logfile.log
logCSV=$logfile.csv

# ininiteLoop=no
while [ $# -gt 0 ]; do
    case $1 in
    -h)
        echo "usage: generateCsvLogs.sh [-h][-f][-l]"
        exit 0
        ;;
    -f) folder=$2 ;;
    -l) logfile=$2 ;;
    -*) die "invalid command line option" ;;
    *) ;;
    esac
    shift
done


echo "Logging from $folder into: $logErrors and $logCSV"
rm -f "$logErrors"
rm -f "$logCSV"


declare -A matrix
num_rows=17
num_columns=100

for ((i=0;i<=num_rows;i++)) do
    for ((j=0;j<=num_columns;j++)) do
        if [ "$i" == 0 ]; then
            matrix[$i,$j]=$j
        else
            matrix[$i,$j]=0    
        fi
    done
done

matrix[0,0]=""
matrix[1,0]="Cashwmaxsat-CorePlus"
matrix[2,0]="Cashwmaxsat-Plus"
matrix[3,0]="UWrMaxSat-SCIP"
matrix[4,0]="MaxHS"
matrix[5,0]="WMaxCDCL"
matrix[6,0]="WMaxCDCL-BandAll"
matrix[7,0]="UWrMaxSat"
matrix[8,0]="EvalMaxSAT"
matrix[9,0]="CGSS"
matrix[10,0]="Exact"
matrix[11,0]="z3maxres"
matrix[12,0]="z3wmax"
matrix[13,0]="z3rc2"
matrix[14,0]="z3pd-maxres"
matrix[15,0]="z3maxres-bin"
matrix[16,0]="Pacose"
matrix[17,0]="maxpre2EvalMaxSAT"

for ((i=1;i<=num_rows;i++)) do
    solver=${matrix[$i,0]}
    echo "$solver"
    for file in "$folder"/"$solver"_*.log; do
        errorNumber=$(basename "$file" | cut -d "." -f1 | cut -d "_" -f2)
        # echo "$file --> $errorNumber"
        # errorSolver=$(echo "$file" | cut -d "." -f1 | cut -d "_" -f1 | rev | cut -d "/" -f1 | rev)
        if [[ $errorNumber =~ ^[0-9]+$ ]]; then
            number=$(grep -a "\!$errorNumber" "$file" | grep -c "$solver ")
            echo "Processing solver $solver with $number errors of kind: $errorNumber <-- Filename: $file"
            grep -a "\!$errorNumber" "$file" | grep "$solver " >> "$logErrors"
            matrix[$i,$errorNumber]=$number
        fi
    done
done

for ((i=0;i<=num_rows;i++)) do
    for ((j=0;j<=num_columns;j++)) do
        echo -n "${matrix[$i,$j]};" >> "$logCSV"
    done
    echo "" >> "$logCSV"
done
