#!/bin/bash

folder=FaultOverview
logfile=FaultList

# ininiteLoop=no
while [ $# -gt 0 ]; do
    case $1 in
    -h)
        echo "usage: getAllFailureCodes.sh [-h][-f]"
        exit 0
        ;;
    -f) folder=$2 ;;
    # -l) logfile=$2 ;;
    -*) die "invalid command line option" ;;
    *) ;;
    esac
    shift
done

num_failures=60
for ((i=1;i<=num_failures;i++)) do
    faultySolver=$(find "$folder"/*.log -exec grep -m 1 "\!$i " {} \; -quit | cut -d " " -f2)
    FaultDescription=$(find "$folder"/*.log -exec grep -A20 -m 1 "\!$i " {} \; -quit | grep "FAULT DESCRIPTION" | grep -m1 "$faultySolver" | cut -d " " -f6-)
    if [ "$FaultDescription" != "" ];then
      echo "$i: $FaultDescription"
    fi
done



