import re

def check_solver_fault_pairs(file_path):
    with open(file_path, 'r') as f:
        lines = f.readlines()

    i = 0
    while i < len(lines):
        if lines[i].startswith('c WCNF-FILE'):
            # Extract SOLVERNAME_FAULTVALUE from the WCNF-FILE line
            match = re.search(r'/([^/]+)_([^_]+)_', lines[i])
            if match:
                wcnf_solvername, wcnf_faultvalue = match.groups()
            else:
                print(f"Couldn't extract SOLVERNAME_FAULTVALUE from line {i}: {lines[i].strip()}")
                i += 1
                continue

            found_combination = False
            matching_line = None
            i += 1
            while i < len(lines) and not lines[i].startswith('c WCNF-FILE'):
                if lines[i].startswith('c '):
                    # Extract SOLVERNAME and FAULTVALUE from the line
                    match = re.search(r'c\s+(\S+)\s+!\s*(\d+)', lines[i])
                    if match:
                        solvername, faultvalue = match.groups()
                        if solvername == wcnf_solvername:
                            matching_line = lines[i]
                            if faultvalue == wcnf_faultvalue:
                                print(wcnf_solvername + " " + wcnf_faultvalue + f" {lines[i].strip()}")
                                found_combination = True
                                break
                i += 1

            if not found_combination and matching_line is not None:
                print("FAULT: " + wcnf_solvername + " " + wcnf_faultvalue + f" {matching_line.strip()}")

        else:
            i += 1


file_path = 'reducedRunreduced.log'  # Replace with your file path
check_solver_fault_pairs(file_path)
