#!/bin/bash

folder=FaultOverview
from=1
to=10

# ininiteLoop=no
while [ $# -gt 0 ]; do
    case $1 in
    -h)
        echo "usage: startDDMIN.sh [-h][-a <from>][-b <to>][-f <folder>] "
        exit 0
        ;;
    -f) folder=$2 ;;
    -a) from=$2 ;;
    -b) to=$2 ;;
    -*) die "invalid command line option" ;;
    *) ;;
    esac
    shift
done



tailing=$((to - from))
tailing=$((tailing + 1))
filesToProcess=$(find "$folder"/*.log | wc -l)
filesToProcess=$((filesToProcess * tailing))
echo "$filesToProcess files to process!"
mkdir -p "$folder"/reduced/logs/
counter=0
for file in "$folder"/*.log; do
    echo ""
    numberOfFaults=$(grep -c "c SEED...." "$file")
    if [ "$numberOfFaults" -lt "$to" ]; then
      counter=$((counter + 1))
      echo "    skip file $counter -- it has too few faults ($numberOfFaults) in it."
      
      continue
    fi
    basename=$(basename "$file")
    faultNumber=$(echo "$basename" | cut -d "." -f1 | cut -d "_" -f2)
    faultySolver=$(echo "$basename" | cut -d "." -f1 | cut -d "_" -f1)
    faultSeeds=$(grep "c SEED...." "$file" | head -n"$to" | tail -n$tailing)
    echo "Processing solver $faultySolver with errors of kind: $faultNumber <-- Filename: $(basename "$file")"
    while read -r p; do
        counter=$((counter + 1))
        seed=${p:17}
        bug=faulty/bug-$seed.wcnf
        red="$folder"/reduced/"$faultySolver"_"$faultNumber"_red-"$seed".wcnf
        echo "$counter of $filesToProcess files. Delta debug $bug --> $red"
        ./wcnfddmin -e 0 -r "$red" -s ../../MaxSATSolver/compare.py_--solvers_"$faultySolver"_--logAll_--saveWCNF "$bug"
        ../../MaxSATSolver/compare.py --logging --solvers "$faultySolver" --logPath "$folder"/reduced/logs/ "$red"
    done < <(echo "$faultSeeds")
done
