## ./startDDMINInParallel.sh -f 2023-04-23-29-FaultOverview -a 1 -b 1 && ./startDDMINInParallel.sh -f 2023-04-23-29-FaultOverview -a 2 -b 2&& ./startDDMINInParallel.sh -f 2023-04-23-29-FaultOverview -a 3 -b 3 && ./startDDMINInParallel.sh -f 2023-04-23-29-FaultOverview -a 4 -b 4 && ./startDDMINInParallel.sh -f 2023-04-23-29-FaultOverview -a 5 -b 5
#!/bin/bash

folder=FaultOverview
from=1
to=10

# ininiteLoop=no
while [ $# -gt 0 ]; do
    case $1 in
    -h)
        echo "usage: startDDMIN.sh [-h][-a <from>][-b <to>][-f <folder>] "
        exit 0
        ;;
    -f) folder=$2 ;;
    -a) from=$2 ;;
    -b) to=$2 ;;
    -*) die "invalid command line option" ;;
    *) ;;
    esac
    shift
done

tailing=$((to - from))
tailing=$((tailing + 1))
filesToProcess=$(find "$folder"/*.log | wc -l)
filesToProcess=$((filesToProcess * tailing))
echo "$filesToProcess files to process!"
mkdir -p "$folder"/reduced/logs/
counter=0

commandList=()
compareList=()
for file in "$folder"/*.log; do
    command_list+=('echo ""')
    numberOfFaults=$(grep -a -c "c SEED...." "$file")
    if [ "$numberOfFaults" -lt "$from" ]; then
        counter=$((counter + 1))
        command_list+=("echo \"    skip file $counter -- it has too few faults ($numberOfFaults) in it.\"")

        continue
    fi
    basename=$(basename "$file")
    faultNumber=$(echo "$basename" | cut -d "." -f1 | cut -d "_" -f2)
    faultySolver=$(echo "$basename" | cut -d "." -f1 | cut -d "_" -f1)

    faultSeeds=""
    if [ "$numberOfFaults" -lt "11" ]; then
        faultSeeds=$(grep -a "c SEED...." "$file" | head -n"$to" | tail -n$tailing)
    else
        faultSeeds=$(grep -a "c SEED...." "$file" | tail -n"$to" | tail -n$tailing)
    fi
   
    command_list+=("echo \"Processing solver $faultySolver with errors of kind: $faultNumber <-- Filename: $(basename $file)\"")
    while read -r p; do
        counter=$((counter + 1))
        seed=${p:17}
        bug=/tmp/bug-$seed.wcnf
        ./wcnfuzz -w "$seed" > "$bug"
        red="$folder"/reduced/"$faultySolver"_"$faultNumber"_red-"$seed".wcnf
        command_list+=( "echo \"$counter of $filesToProcess files. Delta debug $bug --> $red\"" )
        command_list+=( "./wcnfddmin -e 0 -r $red -s ../../MaxSATSolver/compare.py_--solvers_""$faultySolver""_--logAll_--saveWCNF $bug" )
        compare_list+=( "../../MaxSATSolver/compare.py --logging --solvers $faultySolver --logPath $folder/reduced/logs/ $red" )
    done < <(echo "$faultSeeds")
done

num_cores=16
num_running=0
counter=0
for command in "${command_list[@]}"; do
    
    if [ "${command:0:4}" = "echo" ]; then
        eval "$command"
        continue
    fi
    counter=$((counter + 1))
    rand=$RANDOM
    echo "$command > ddminLogs/ddmin$counter\_$rand.log 2>&1"
    eval "$command > ddminLogs/ddmin$counter\_$rand.log 2>&1" &
    num_running=$((num_running + 1))
    if [ "$num_running" = "$num_cores" ]; then
        wait -n
        num_running=$((num_running - 1))
    fi
done


