#!/bin/bash

folder=FaultOverview
from=1
to=10
useSeed="0"
wcnfFolder=""
# ininiteLoop=no
while [ $# -gt 0 ]; do
    case $1 in
    -h)
        echo "usage: startDDMIN.sh [-h][-a <from>][-b <to>][-f <folder>] "
        exit 0
        ;;
    -f) folder=$2 ;;
    -w) wcnfFolder=$2 ;;
    -a) from=$2 ;;
    -b) to=$2 ;;
    -s) useSeed="1" ;;
    -*) die "invalid command line option" ;;
    *) ;;
    esac
    shift
done

tailing=$((to - from))
tailing=$((tailing + 1))
filesToProcess=$(find "$folder"/*.log | wc -l)
echo "$filesToProcess files to process!"
filesToProcess=$((filesToProcess * tailing))
echo "Maximal $filesToProcess files to generate!"
mkdir -p "$folder"/reduced/logs/
counter=0
solverCounter=0
for file in "$folder"/*.log; do
    #echo ""
    numberOfFaults=$(grep -c "c SEED...." "$file")
    if [ "$numberOfFaults" -lt "$from" ]; then
        counter=$((counter + 1))

        continue
    fi
    basename=$(basename "$file")
    faultNumber=$(echo "$basename" | cut -d "." -f1 | cut -d "_" -f2)
    faultySolver=$(echo "$basename" | cut -d "." -f1 | cut -d "_" -f1)
    faultySeeds=""
    if [ "$useSeed" -eq "1" ]; then
    	faultSeeds=$(grep -a "c SEED...." "$file" | tail -n"$to" | tail -n"$tailing")
    else
    	faultSeeds=$(grep -a "c WCNF-FILE....: " "$file" | tail -n"$to" | tail -n"$tailing")
    fi
    
    solverCounter=0
    correctOutput=0
    wrongOutput=0
    while read -r p; do
        counter=$((counter + 1))
        solverCounter=$((solverCounter + 1))
        seed=""
        bug=""
        if [ "$useSeed" -eq "1" ]; then
          seed=${p:17}
          bug=/tmp/bug-$seed.wcnf
          ./wcnfuzz -w "$seed" > "$bug"
        else
          bug="${p:22}"
          bug="${bug::-5}"
          for file in "$wcnfFolder/$bug"*; do
#            echo "$file"
            if [ -f "$file" ]; then
              bug=$file
            
              break
            fi
          done
        fi
        
        #red="$folder"/reduced/"$faultySolver"_"$faultNumber"_red-"$seed".wcnf
 #       echo "$counter of $filesToProcess files. Call compare to detect $faultNumber in file $bug"
        output=$(../../MaxSATSolver/compare.py --solvers "$faultySolver" "$bug")
        if [ "$numberOfFaults" -eq "1" ]; then
          rm -f "$bug"
        fi
        output=$(grep -a "\!$faultNumber" <<<"$output" | grep -a "$faultySolver")
        if [ -z "$output" ]; then
            wrongOutput=$((wrongOutput + 1))
        else
            correctOutput=$((correctOutput + 1))
        fi
    done < <(echo "$faultSeeds")
    echo "$faultySolver has $correctOutput / $solverCounter verified occurences of failure $faultNumber."
    if [ "$correctOutput" -eq "0" ]; then
        echo "ERROR: $faultySolver $faultNumber $correctOutput / $solverCounter"
    fi
done
