#!/bin/bash

die() {
  echo "*** runcnfuzz: $*" 1>&2
  exit 1
}
prg=""
maxsat="--wcnf"
first=no
while [ $# -gt 0 ]; do
  case $1 in
  -h)
    echo "usage: runwcnfuzz [-h][-q][-m][-i][-I][-f][-n][-k] <prg> [<prgopts>...]"
    exit 0
    ;;
  -f) first=yes ;;
  --version)
    echo "2"
    exit 0
    ;;
  -*) die "invalid command line option" ;;
  *)
    prg="$*"
    break
    ;;
  esac
  shift
done
[ "$prg" = "" ] && die "no program specified"
base=/tmp/runwcnfuzz-$$
wcnf=$base.wcnf
sol=$base.sol
# err=$base.err
log=$base-$$.log
rm -f $log
trap "rm -f $base*;exit 1", 2 15
gitHash=$(git rev-parse --verify HEAD)
i=0
# unsat=0
# sat=0
#lines=0
echo "[runwcnfuzz] running $prg"
echo "[runwcnfuzz] logging $log"
echo "[runwcnfuzz] generating MaxSAT formulas"
echo "[runwcnfuzz] ignoring zero exit code"
echo "[runwcnfuzz] adding the following git SHA1 $gitHash to each instance"
COUNTER2=0
FAULTY=0
FAULTFREE=0
while true; do
  COUNTER2=$((COUNTER2 + 1))
  # rm -f $wcnf
  rm -f "$bug"
  rm -f "$sol"
  ./wcnfuzz $maxsat -g "$gitHash" "$CNFUZZOPTIONS" >$wcnf
  seed=$(grep 'c seed' $wcnf | head -1 | awk '{print $NF}')
  echo "[runwcnfuzz] Seed: $seed"
  bug="bug-$seed.wcnf"
  # mv $wcnf /tmp/$bug

  # COUNTER=0
  #  while [ $COUNTER -lt $lines ]; do
  #    COUNTER=$(expr $COUNTER + 1)
  #    tput cuu1
  #  done
  #  lines=0
  #  lines=$(expr $lines + 1)
  #echo " sat, unsat = $sat, $unsat " \\r:
  #printf "%d %d %d %d\r" "$i" "$seed" $head
  #  printf "sat, unsat, calls = %d, %d, %d\r" "$sat" "$unsat" `expr $l + $k`
  #  echo -ne "sat, unsat = $sat, $unsat "\\r:
  i=$((i + 1))
  #rm -f $sol

  # eval $prg $wcnf 2>&1 | tee -a $sol
  eval "$prg" "$wcnf"

  res=${PIPESTATUS[0]}
  #lines=$(expr $lines + 1)../ins
  case $res in
  # 10)
  #   sat=$(expr $sat + 1)
  #   continue
  #   ;;
  # 20)
  #   unsat=$(expr $unsat + 1)
  #   continue
  #   ;;
  0)
    FAULTFREE=$((FAULTFREE + 1))
    echo "[runwcnfuzz] Return value: $res in iteration(faulty, faultfree): $COUNTER2 ($FAULTY, $FAULTFREE) "
    continue
    ;;
  esac
  FAULTY=$((FAULTY + 1))
  echo "[runwcnfuzz] Return value: $res in iteration(faulty, faultfree): $COUNTER2 ($FAULTY, $FAULTFREE) "

  #lines=$(expr $lines + 1)
  #echo "after $res, $sat, $unsat "
  # log="log-$seed.log"
  # header=$(grep '^c ' $wcnf)
  #echo "$seed" > $log
  # echo "[runwcnfuzz] Return value: $res in iteration(faulty, faultfree): $COUNTER2 ($FAULTY, $FAULTFREE) " > $log
  echo "[runwcnfuzz] Return value: $res in iteration(faulty, faultfree): $COUNTER2 ($FAULTY, $FAULTFREE) "
  # echo "$header" >> $log
  # cat $sol >> $log

  #cp -p $sol $log
  # red="red-$seed.wcnf"
  bug="bug-$seed.wcnf"
  #echo "$log, $red, $bug"

  mv "$wcnf" faulty/"$bug"
  # echo "[runwcnfuzz] reduce $prg $bug" | tee -a $log
  #  ./wcnfddmin -C -e 0 -r $red -s $prg $wcnf 2>&1 | tee -a $log

  # mv $bug faulty
  # mv $red faulty
  # mv $log faulty
  [ $first = yes ] && exit 0
done
